; JEDNODUCHA OBSLUHA MULTIPLEXNI MATICOVE KLAVESNICE

; poznamka - symbol (*) znaci, ze velicina je pouze adresou promenne

; inicializace klavesnice
KEY_INIT	MACRO	IREGISTR, EIBIT, IBIT, PORTX, KB, K_OUT, KROK
; IREGISTR - adresa registru, ktery obsahuje priznak nebo povoleni preruseni
;            pro zvoleny casovac
; EIBIT - bit v IREGISTRu, ktery povoluje preruceni od casovace
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna

	banksel	128	; nastaveni banky, ve ktere je IREGISTR urcen k povoleni/zakazani preruseni od casovace
	BSF	IREGISTR, EIBIT	; povoleni preruseni od casovace
	MOVLW	B'11101111'	; nastaveni TRIS registru pro PORTX (take banka 1)
	MOVWF	PORTX
	banksel	0
	MOVLW	B'00000000'	; nastaveni PORT registru (na nulovy potencial)
	MOVWF	PORTX
	CLRF	KB		; vynulovani pomocnych promennych
	CLRF	KB+1
	CLRF	K_OUT
	CLRF	K_OUT+1
	CLRF	KROK
	BCF	IREGISTR, IBIT	; vynulovani priznaku od casovace
	ENDM

; obsluha klavesnice (pro system preruseni)
KEY_IPROG	MACRO	IREGISTR, IBIT, PORTX, KB, K_OUT, KROK, XTEMP
; IREGISTR - adresa registru, ktery obsahuje priznak preruseni
;            pro zvoleny casovac
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; XTEMP* - pomocna promenna

	LOCAL	KONEC
	
	banksel	IREGISTR
	BTFSS	IREGISTR,IBIT	; kontrola priznaku od casovace...
	GOTO	KONEC
	BCF	IREGISTR,IBIT	; ... a vynulovani tohoto priznaku
	MOVF	PORTX,W		; precteni ctyr bitu portu...
	ANDLW	B'00001111'	; ...a pricteni do KB/KB+1 podle...
	BTFSC	KROK,0		; ...hodnoty v promenne KROK
	SWAPF	PORTX,W
	BTFSC	KROK,0
	ANDLW	B'11110000'
	BTFSS	KROK,1
	IORWF	KB,F
	BTFSC	KROK,1
	IORWF	KB+1,F

	INCF	KROK,F		; zvyseni hodnoty v promenne KROK

	MOVLW	B'11101111'	; nastaveni na prvni ridici vodic
	MOVWF	XTEMP
	BSF	STATUS,C		; provedeme tolik posunu doleva,...
	BTFSC	KROK,0		; ... kolik ukazuje promenna KROK
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	MOVF	XTEMP,W
	IORLW	B'00001111'	; odfiltrovani "smeti"
	BSF	STATUS,RP0
	MOVWF	PORTX		; nastaveni TRIS registru - ten definuje napajeni ridicich vodicu
	BCF	STATUS,RP0
	
	MOVF	KROK,W		; pokud KROK pretekl na dalsi hodnotu "4"...
	ANDLW	B'00000011'
	BTFSS	STATUS,Z
	GOTO	KONEC
	
	MOVF	KB,W		; ...zkopirujeme KB do K_OUT...
	MOVWF	K_OUT
	MOVF	KB+1,W
	MOVWF	K_OUT+1
	CLRF	KB		; ... a KB vynulujeme
	CLRF	KB+1
KONEC
	ENDM
