	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

;---------------------------------------------

	#include	buffer.inc
	#include	znaky.inc
	#include	displej.inc
	#include	key_int1.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

TXBSIZE	EQU	16	; velikost vysilaciho bufferu

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TMH:1	; pro obsluhu displeje
	TML:1
	DDATA:1
	TXUIN:1	; pro obsluhu bufferu
	TXUOUT:1
	TXBSTAT:1
	TXTEMP:1
	TXBADR:TXBSIZE
	KB:2	; pro obsluhu klavesnice
	OUTB:2
	COUNTER:1
	KEYTEMP:1
	ENDC
	
	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

	ORG	0
	NOP		; kvuli ZAVADECI
	NOP		; kvuli ZAVADECI
	NOP		; kvuli ZAVADECI
	GOTO	START

	ORG	4		; Vektor preruseni
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP

	; obsluha bufferu pro vystup
	TXBUFF_I	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT

	; obsluha klavesnice
	KEY_IPROG	INTCON, T0IF, PORTD, KB, OUTB, COUNTER, KEYTEMP

	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE			; konec odsluhy preruseni



START	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0

	; inicializace vysilaciho bufferu
	TXBUFFINI	TXUIN, TXUOUT, TXBSTAT

	MOVLW	B'00000010' ; nastaveni casovace TIMER0...
	banksel	OPTION_REG  ; ...s predelickou "8"
	MOVWF	OPTION_REG
	banksel	0

	; inicializace klavesnice
	KEY_INIT	INTCON, T0IE, T0IF, PORTD, KB, OUTB, COUNTER

	;inicializace displeje
	CALL	INITDISP

	; na displeji bude vypsano: "TEST KLAVESNICE"
	MOVLW	D'6'
	CALL	SETPOS
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK

	MOVLW	D'64' + 3
	CALL	SETPOS
	MOVLW	ZNAK_K
	CALL	PUTZNAK
	MOVLW	ZNAK_L
	CALL	PUTZNAK
	MOVLW	ZNAK_A
	CALL	PUTZNAK
	MOVLW	ZNAK_V
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_N
	CALL	PUTZNAK
	MOVLW	ZNAK_I
	CALL	PUTZNAK
	MOVLW	ZNAK_C
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK

	BSF	INTCON,PEIE	; povoleni preruseni od periferii
	BSF	INTCON,GIE	; konecna aktivace celeho systemu preruseni

LOOP	MOVLW	D'250'		; prodleva (pouzil jsem DDELAY z obsluhy displeje)
	CALL	DDELAY
	MOVLW	D'133'		; synchronizacni (uvodni) byte
	CALL	PUTBYTE		; ...poslat do bufferu
	BCF	INTCON,GIE	; zablokovani systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVF	OUTB,W		; stav klavesnice je (invertovany) poslan do bufferu
	XORLW	B'11111111'
	CALL	PUTBYTE
	MOVF	OUTB+1,W
	XORLW	B'11111111'
	CALL	PUTBYTE
	BSF	INTCON,GIE	; system preruseni je obnoven
	MOVLW	D'33'		; synchroniyacni (koncovy) byte
	CALL	PUTBYTE
	GOTO	LOOP		; opakuj cyklus

	; podprogram na pridani znaku do bufferu
PUTBYTE	TXBUFF_P	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT, TXTEMP

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
