program Seriovy_prenos;

uses Crt,Dos;

const _com1 = $3F8; {standartni pocatecni adresy ctyr prvnich portu}
      _com2 = $2F8;
      _com3 = $3E8;
      _com4 = $2E8;

var Scr:array [0 ..199,0..319] of byte absolute $a000:0;
    reg:registers;
    com:word;
    K_pole : array [0..3,0..3] of boolean;
    Z_Bitmaps : array [0..31,0..27,0..31] of byte;
    N_Bitmaps : array [0..9,0..23,0..17] of byte;
    counter : word;
    clen:byte;
    kus1,kus2:byte;
    vyber:byte;

procedure Graph256;
begin
 reg.al:=$13; reg.ah:=0; intr($10,reg);
end;

procedure CloseGraph256;
begin
 TextMode(CO80);
end;

function inport:byte; {precti port (jako cislo)}
begin
 inport:=port[com];
end;

function RCif:boolean; {indikator prichazejiciho bytu - vrati true, pokud je na vstupu novy znak}
begin
 RCif := ((port[com+5] and 1) = 1); {indikace nulteho bitu}
end;

procedure OpenPort; {pripravi port k pouziti}
begin
 port[com+1] := $00;
 port[com+3] := $80;
 port[com+0] := $06; {vybrane rychlosti : 0C=9600, 06=19200, 03=38400, 02=57600, 01=115200}
 port[com+1] := $00;
 port[com+3] := $03;
 port[com+2] := $C7;
 port[com+4] := $0B; { bity 0 a 1 aktivuji vyvody DTR a RTS, ktere mohou slouzit i jako napajeni}
end;

procedure ClosePort; {uzavre port, aby jej mohli pouzivat jine aplikace}
begin
 port[com+4] := $00;
end;

procedure Blok(x,y,dx,dy,color:integer);
var i:integer;
begin
 begin
  for i:=y to y+dy-1 do Move(Z_Bitmaps[color,27-(i-y),0],Scr[i,x],32);
 end
end;

procedure Blok2(x,y,p,n:integer);
var i:integer;
begin
 begin
  for i:=y to y+24-1 do Move(N_Bitmaps[n,23-(i-y),0],Scr[i,x+(18*p)],18);
 end
end;

procedure Nacti(file1:string);
var F1:file;
begin
 Assign(F1,file1);
 ReSet(F1,1);
 BlockRead(F1,Z_Bitmaps,28*32*32);
 BlockRead(F1,N_Bitmaps,18*24*10);
 Close(F1);
end;

procedure Zobraz(kus1,kus2:byte);
var i,j:integer;
begin
 inc(counter);
 Blok2(0,0,0,counter div 10000);
 Blok2(0,0,1,(counter mod 10000) div 1000);
 Blok2(0,0,2,(counter mod 1000) div 100);
 Blok2(0,0,3,(counter mod 100) div 10);
 Blok2(0,0,4,(counter mod 10));

 for i:=0 to 3 do for j:=0 to 3 do k_pole[i,j]:=false;
 if (kus1 and   1)>0 then k_pole[0,0]:=true;
 if (kus1 and   2)>0 then k_pole[1,0]:=true;
 if (kus1 and   4)>0 then k_pole[2,0]:=true;
 if (kus1 and   8)>0 then k_pole[3,0]:=true;
 if (kus1 and  16)>0 then k_pole[0,1]:=true;
 if (kus1 and  32)>0 then k_pole[1,1]:=true;
 if (kus1 and  64)>0 then k_pole[2,1]:=true;
 if (kus1 and 128)>0 then k_pole[3,1]:=true;
 if (kus2 and   1)>0 then k_pole[0,2]:=true;
 if (kus2 and   2)>0 then k_pole[1,2]:=true;
 if (kus2 and   4)>0 then k_pole[2,2]:=true;
 if (kus2 and   8)>0 then k_pole[3,2]:=true;
 if (kus2 and  16)>0 then k_pole[0,3]:=true;
 if (kus2 and  32)>0 then k_pole[1,3]:=true;
 if (kus2 and  64)>0 then k_pole[2,3]:=true;
 if (kus2 and 128)>0 then k_pole[3,3]:=true;
 for i:=0 to 3 do for j:=0 to 3 do
 begin
  if k_pole[j,3-i] then Blok(120+40*i,40+35*j,32,28,((j*4)+i)+0)
                 else Blok(120+40*i,40+35*j,32,28,((j*4)+i)+16)
 end;
end;

begin
 ClrScr;
 Writeln('>> MONITOROVANI 16TLACITKOVE KLAVESNICE <<');
 Writeln;
 Writeln(' Zvolte seriovy port :');
 Writeln(' (1) - COM1');
 Writeln(' (2) - COM2');
 Writeln(' (3) - COM3');
 Writeln(' (4) - COM4');
 repeat
  vyber := byte(UpCase(ReadKey));
 until (vyber = 49) or (vyber = 50) or (vyber = 51) or (vyber = 52) or (vyber=27);
 if vyber = 49 then com := _com1;
 if vyber = 50 then com := _com2;
 if vyber = 51 then com := _com3;
 if vyber = 52 then com := _com4;
 if not(vyber = 27) then
 begin
  Nacti('znaky.dat');
  if IOResult<>0 then
  begin
    Writeln;
    TextColor(12);
    Writeln('  !!! CHYBA - Soubor "ZNAKY.DAT" nenalezen !!!');
    TextColor(7);
    ReadKey;
  end else
  begin
   ClrScr;
   Writeln('Spustte Chipon 2 i s programem, ktery monitoruje 16tlacitkovou klavesnici!');
   Writeln('Pokud je jiz Chipon spusten a pripojen, potom nejspise musite stisknout');
   Writeln('nekterou jeho klavesu...');
   OpenPort; {otevri vybrany port}
   clen:=0;
   counter:=0;
   repeat
    repeat until (RCif) or (KeyPressed); {cekani na prichozi znak, nebo stisk klavesy}
    case clen of
    0 : if inport=133 then clen:=1;
    1 : begin
         kus1 := inport;
         clen := 2;
        end;
    2 : begin
         kus2 := inport;
         clen := 3;
        end;
    3 : begin
         if inport=33  then clen := 4 else clen:=0;
        end;
    else clen := 0;
    end;
   until (KeyPressed) or (clen=4);

   Graph256;
   clen:=0;
   repeat
    repeat until (RCif) or (KeyPressed); {cekani na prichozi znak, nebo stisk klavesy}
    case clen of
    0 : if inport=133 then clen:=1;
    1 : begin
         kus1 := inport;
         clen := 2;
        end;
    2 : begin
         kus2 := inport;
         clen := 3;
        end;
    3 : begin
         if inport=33  then Zobraz(kus1,kus2);
         clen := 0;
        end;
    else clen := 0;
    end;
   until KeyPressed;
   ReadKey;
   CloseGraph256;
   ClosePort; {uzavri vybrany port}
  end;
 end;
end.