	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	buffer.inc
	#include	znaky.inc
	#include	displej.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

TXBSIZE	EQU	32	; velikost vysilaciho bufferu

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TMH:1	; pro obsluhu displeje
	TML:1
	DDATA:1
	TXUIN:1	; pro obsluhu bufferu
	TXUOUT:1
	TXBSTAT:1
	TXTEMP:1
	TXBADR:TXBSIZE
	ENDC
	
	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

	ORG	0
	NOP		; kvuli ZAVADECI
	NOP		; kvuli ZAVADECI
	NOP		; kvuli ZAVADECI
	GOTO	START

	ORG	4		; Vektor preruseni
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP

	; obsluha bufferu pro vystup
	TXBUFF_I	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT

	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

START	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0

	; inicializace vysilaciho bufferu
	TXBUFFINI	TXUIN, TXUOUT, TXBSTAT
	
	; inicializace displeje
	CALL	INITDISP

	; na displeji bude vypsano: "TEST BUFFERU"
	MOVLW	D'6'
	CALL	SETPOS
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	D'64' + 4
	CALL	SETPOS
	MOVLW	ZNAK_B
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_R
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK

	BSF	INTCON,PEIE	; povoleni preruseni od periferii
	BSF	INTCON,GIE	; konecna aktivace celeho systemu preruseni

	; nyni je do bufferu zapsan 32znakovy text:
	MOVLW	ZNAK_T
	CALL	PUTBYTE
	MOVLW	ZNAK_E
	CALL	PUTBYTE
	MOVLW	ZNAK_S
	CALL	PUTBYTE
	MOVLW	ZNAK_T
	CALL	PUTBYTE
	MOVLW	ZNAK_SP
	CALL	PUTBYTE

	MOVLW	ZNAK_B
	CALL	PUTBYTE
	MOVLW	ZNAK_U
	CALL	PUTBYTE
	MOVLW	ZNAK_F
	CALL	PUTBYTE
	MOVLW	ZNAK_F
	CALL	PUTBYTE
	MOVLW	ZNAK_E
	CALL	PUTBYTE
	MOVLW	ZNAK_R
	CALL	PUTBYTE
	MOVLW	ZNAK_U
	CALL	PUTBYTE
	MOVLW	ZNAK_SP
	CALL	PUTBYTE

	MOVLW	ZNAK_N
	CALL	PUTBYTE
	MOVLW	ZNAK_A
	CALL	PUTBYTE
	MOVLW	ZNAK_SP
	CALL	PUTBYTE

	MOVLW	ZNAK_C
	CALL	PUTBYTE
	MOVLW	ZNAK_E
	CALL	PUTBYTE
	MOVLW	ZNAK_L
	CALL	PUTBYTE
	MOVLW	ZNAK_Y
	CALL	PUTBYTE
	MOVLW	ZNAK_C
	CALL	PUTBYTE
	MOVLW	ZNAK_H
	CALL	PUTBYTE
	MOVLW	ZNAK_SP
	CALL	PUTBYTE

	MOVLW	ZNAK_3
	CALL	PUTBYTE
	MOVLW	ZNAK_2
	CALL	PUTBYTE
	MOVLW	ZNAK_SP
	CALL	PUTBYTE

	MOVLW	ZNAK_Z
	CALL	PUTBYTE
	MOVLW	ZNAK_N
	CALL	PUTBYTE
	MOVLW	ZNAK_A
	CALL	PUTBYTE
	MOVLW	ZNAK_K
	CALL	PUTBYTE
	MOVLW	ZNAK_U
	CALL	PUTBYTE
	MOVLW	B'00100001'
	CALL	PUTBYTE

LOOP	GOTO	LOOP

	; podprogram na pridani znaku do bufferu
PUTBYTE	TXBUFF_P	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT, TXTEMP

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
