	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	buffer.inc
	#include	znaky.inc
	#include	displej.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

TXBSIZE	EQU	16	; velikost vysilaciho bufferu
RCBSIZE	EQU	16	; velikost prijimaciho bufferu

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TMH:1	; pro obsluhu displeje
	TML:1
	DDATA:1
	TXUIN:1	; pro obsluhu dvou bufferu
	TXUOUT:1
	TXBSTAT:1
	TXTEMP:1
	TXBADR:TXBSIZE
	RCUIN:1
	RCUOUT:1
	RCBSTAT:1
	RCTEMP:1
	RCFLAGS:1
	RCBADR:RCBSIZE
	CITAC:1	; pomocna promenna
	ENDC
	
	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

	ORG	0
	NOP		; kvuli ZAVADECI
	NOP		; kvuli ZAVADECI
	NOP		; kvuli ZAVADECI
	GOTO	START

	ORG	4		; Vektor preruseni
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP

	; obsluha bufferu pro vstup
	RCBUFF_I	RCBADR, RCBSIZE, RCUIN, RCUOUT, RCBSTAT, RCFLAGS

	; obsluha bufferu pro vystup
	TXBUFF_I	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT

	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

START	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0

	; inicializace vysilaciho bufferu
	TXBUFFINI	TXUIN, TXUOUT, TXBSTAT

	; inicializace prijimaciho bufferu
	RCBUFFINI	RCUIN, RCUOUT, RCBSTAT, RCFLAGS
	
	; inicializace displeje
	CALL	INITDISP

	; na displeji bude vypsano: "DRUHY TEST BUFFERU"
	MOVLW	D'3'
	CALL	SETPOS
	MOVLW	ZNAK_D
	CALL	PUTZNAK
	MOVLW	ZNAK_R
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK
	MOVLW	ZNAK_H
	CALL	PUTZNAK
	MOVLW	ZNAK_Y
	CALL	PUTZNAK
	MOVLW	ZNAK_SP
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	D'64' + 4
	CALL	SETPOS
	MOVLW	ZNAK_B
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_R
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK

	BSF	INTCON,PEIE	; povoleni preruseni od periferii
	BSF	INTCON,GIE	; konecna aktivace celeho systemu preruseni

LOOP	BTFSS	RCBSTAT,3		; cekame, az bude ve vstupnim bufferu 8 znaku
	GOTO	LOOP
	MOVLW	D'8'		; potom techto 8 znaku...
	MOVWF	CITAC
PRESUN	CALL	GETBYTE		; ...zkopirujeme do...
	CALL	PUTBYTE		; ...vystupniho bufferu
	DECFSZ	CITAC,F
	GOTO	PRESUN	
	GOTO	LOOP

	; podprogram na pridani znaku do bufferu
PUTBYTE	TXBUFF_P	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT, TXTEMP

	; podprogram na precteni znaku z bufferu
GETBYTE	RCBUFF_P	RCBADR, RCBSIZE, RCUIN, RCUOUT, RCBSTAT, RCTEMP

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
