	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	znaky.inc
	#include	displej.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TMH:1	; pro obsluhu displeje
	TML:1
	DDATA:1
	ENDC
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	; inicializace displeje
	CALL	INITDISP

	; na displeji bude vypsano: "TEST BEZ BUFFERU"
	MOVLW	D'6'
	CALL	SETPOS
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	D'64' + 2
	CALL	SETPOS
	MOVLW	ZNAK_B
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_Z
	CALL	PUTZNAK
	MOVLW	ZNAK_SP
	CALL	PUTZNAK
	MOVLW	ZNAK_B
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_R
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK

LOOP	BTFSS	PIR1,RCIF		; pokud na port prisel znak...
	GOTO	LOOP
	MOVF	RCREG,W		; ...zkopiruj jej na vystup
	MOVWF	TXREG
	GOTO	LOOP

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
